{
  Autor: Michael Springwald

  Datum: Montag, 25.05.2015
}

program tcp_console;

{$mode objfpc}{$H+}

uses
  cthreads, Classes, sysutils, Crt,
  uplTCP_Synapse;

type
  { TPLApp }
  TPLApp = class
  private

  protected

  public
    Server:TPLTCP_Server;

    ClientList:TPLTCP_ClientList;

    constructor Create;
    destructor Destroy; override;

    procedure RunApp;

    procedure OnAddClient(const NewClient:TPLTCP_Client);
    procedure OnReseived(Client:TPLTCP_Client; const msg:string);

  published
  end; // TPLTCPServer

{ TPLApp }
constructor TPLApp.Create;
begin
  inherited Create;
  ClientList:=nil;
end;

destructor TPLApp.Destroy;
begin
  inherited Destroy;
end;

procedure TPLApp.RunApp;
var
  NewClient:TPLTCP_Client;
  Quit:Boolean;
  s:string;
  c:char;
  i:integer;
begin

  if Paramcount <= 5 then begin
    Server:=TPLTCP_Server.Create(true);
    Server.OnAddClient:=@OnAddClient;
    Server.ClientList.OnReceived:=@OnReseived;

    // Progamm wird als Server gestartet
    if ParamStr(1) = 'server' then begin
      Server.StartServer(ParamStr(2),StrToInt(ParamStr(3)));
    end;

    // Programm wird als Client gestartet
    if ParamStr(1) = 'client' then begin
      ClientList:=TPLTCP_ClientList.Create;
      ClientList.OnReceived:=@OnReseived;

      NewClient:=ClientList.AddClient('','');
      NewClient.StartSocket(ParamStr(2),StrToInt(ParamStr(3)));
      NewClient.Send('NewClient:'+ParamStr(4));
    end;

    Quit:=False;
    repeat
      if Keypressed then begin
        c := Readkey;
        case c of
          #13: begin
            if Assigned(ClientList) then begin
              if ClientList.Count > 0 then
                ClientList[0].Send(s);
            end
            else begin
              writeln('Clients in der Liste:',Server.ClientList.Count-1);
              for i:=0 to Server.ClientList.Count-1 do begin
                Server.ClientList[i].Send('[Server] - ' + s);
              end;
            end;
            s:='';
            Writeln;
          end;
          #27: begin
            Quit:=true;
          end
          else begin
            s := s + c;
            Write(c);
          end;
        end;
      end
      else begin
        sleep(100);
      end;

    until Quit;

    if Assigned(ClientList) then begin
      ClientList.Free;
    end
  end
  else begin
    writeln('Aufruf mit: Server/client Host Port [CLientID]');
  end;

end; // TPLApp.RunApp

procedure TPLApp.OnAddClient(const NewClient: TPLTCP_Client);
begin
  writeln('Ein neuer Client!');
end; // TPLApp.OnAddClient

procedure TPLApp.OnReseived(Client: TPLTCP_Client; const msg: string);
begin
  writeln(IntTostr(Client.index)+' ' +msg);

  if Assigned(Server) then begin
    if pos('NewClient',msg) > 0 then begin
    // Client.ID+'_'+IntToStr(i)

    end;
  end;
end; // TPLApp.OnReseived

var
  App:TPLApp;

begin
  App:=TPLApp.Create;
  App.RunApp;
  App.Free;
end.

